unit uutlInterfaces;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  generic IutlEqualityComparer<T> = interface(IUnknown)
    ['{C0FB90CC-D071-490F-BFEE-BAA5C94D1A5B}']
    function EqualityCompare(constref i1, i2: T): Boolean;
  end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  generic IutlComparer<T> = interface(specialize IutlEqualityComparer<T>)
    ['{7D2EC014-2878-4F60-9E43-4CFB54268995}']
    function Compare(constref i1, i2: T): Integer;
  end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  generic IutlFilter<T> = interface(IUnknown)
    function Filter(constref i: T): Boolean;
  end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  generic IutlSelector<Tin, Tout> = interface(IUnknown)
    function Select(constref i: Tin): Tout;
  end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  generic TGenericArray<T> = array of T;
  generic IutlEnumerator<T> = interface(specialize IEnumerator<T>)
    function GetEnumerator: specialize IutlEnumerator<T>;

    function Count:    Integer;

    function Reverse:  specialize IutlEnumerator<T>;
    function Skip      (const aCount: Integer): specialize IutlEnumerator<T>;
    function Take      (const aCount: Integer): specialize IutlEnumerator<T>;

    function Where     (const aComparer: specialize IutlFilter<T>): specialize IutlEnumerator<T>;
    // TODO generic function  Select<S> (const aSelector: specialize IutlSelector<T, S>): specialize IutlEnumerator<S>;

    function ToArray: specialize TGenericArray<T>;
  end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  generic IutlEnumerable<T> = interface(specialize IEnumerable<T>)
    ['{963214EB-EF7C-4785-8B48-8DD9DE0ABDAF}']
    function GetUtlEnumerator: specialize IutlEnumerator<T>;

    property UtlEnumerator: specialize IutlEnumerator<T> read GetUtlEnumerator;
    property Enumerator:    specialize IEnumerator<T>    read GetEnumerator;
  end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  generic IutlReadOnlyArray<T> = interface(IUnknown)
    ['{B0938B6F-4E0D-45E3-A813-056AD4C0A2F2}']
    function GetCount: Integer;
    function GetItem(const aIndex: Integer): T;

    property Count: Integer read GetCount;
    property Items[const aIndex: Integer]: T read GetItem; default;
  end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  generic IutlArray<T> = interface(specialize IutlReadOnlyArray<T>)
    ['{D3618E88-3BF7-4E63-850F-6893A334564A}']
    procedure SetCount(const aValue: Integer);
    procedure SetItem(const aIndex: Integer; aItem: T);

    property Count: Integer read GetCount write SetCount;
    property Items[const aIndex: Integer]: T read GetItem write SetItem; default;
  end;

implementation

end.

